<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="分类" name="alarmType">
						<a-select v-model:value="searchFormState.alarmType" placeholder="请选择分类" :options="[{label:'报警',value:'报警'},{label:'异常',value:'异常'}]"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="标题" name="alarmTitle">
						<a-input v-model:value="searchFormState.alarmTitle" placeholder="请输入标题"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotWorkAlarmSetAdd')">
						<template #icon>
							<plus-outlined/>
						</template>
						新增
					</a-button>
					<a-button danger @click="deleteBatchDepotWorkAlarmSet()" v-if="hasPerm('depotWorkAlarmSetBatchDelete')">删除</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.title === '设为报警'">
					<a-switch
						:loading="statusLoading"
						:checked="record.alarmType === '报警'"
						@change="editAlarmType(record)"
					/>
				</template>
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('depotWorkAlarmSetEdit')">编辑</a>
						<a-divider type="vertical" v-if="hasPerm(['depotWorkAlarmSetEdit', 'depotWorkAlarmSetDelete'], 'and')"/>
						<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotWorkAlarmSet(record)">
							<a-button type="link" danger size="small" v-if="hasPerm('depotWorkAlarmSetDelete')">删除</a-button>
						</a-popconfirm>
					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
</template>

<script setup name="depotWorkAlarmSet">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import depotWorkAlarmSetApi from '@/api/biz/depotWorkAlarmSetApi'
import depotRepayOrderApi from "@/api/biz/depotRepayOrderApi";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const statusLoading = ref(false)
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
const columns = [
	{
		title: '标题',
		dataIndex: 'alarmTitle'
	},
	{
		title: '进程编码',
		dataIndex: 'flowType'
	},
	{
		title: '分类',
		dataIndex: 'alarmType'
	},
	{
		title: '设为报警',
		dataIndex: 'alarmType',
		width: '80px'
	},
	{
		title: '添加时间',
		dataIndex: 'createTime',
		width: '150px'
	},
	{
		title: '更新时间',
		dataIndex: 'updateTime',
		width: '150px'
	},
]
// 操作栏通过权限判断是否显示
if (hasPerm(['depotWorkAlarmSetEdit', 'depotWorkAlarmSetDelete'])) {
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: '150px'
	})
}
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotWorkAlarmSetApi.depotWorkAlarmSetPage(Object.assign(parameter, searchFormParam)).then((data) => {
		return data
	})
}
// 开关
const editAlarmType = (record) => {
	statusLoading.value = true
	depotWorkAlarmSetApi
		.depotWorkAlarmSetSubmitForm({"id": record.id, "alarmType": record.alarmType === '异常' ? '报警' : '异常'}, false)
		.then(() => {
			table.value.refresh(true)
		})
		.finally(() => {
			statusLoading.value = false
		})
}
// 删除
const deleteDepotWorkAlarmSet = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotWorkAlarmSetApi.depotWorkAlarmSetDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotWorkAlarmSet = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotWorkAlarmSetApi.depotWorkAlarmSetDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
</script>
